# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""
from Mapa_PU.kontroler import komunikaty

u"""Obsługa dostępu do bazy danych"""
#import adodbapi

import pyodbc 
#from Mapa_PU.model import pypyodbc

#import win32com.client


class Baza:
    """Dostęp do bazy danych"""
    #Marcin Śliwa
    
    def __init__(self,baza):
        """konstruktor"""
        #import adodbapi
        self.baza=baza
    
#     def polaczAdo(self):
#         """Połaczenie z bazą danych przy pomocy adodbapi"""
#         try:
#             parametr = 'Provider=Microsoft.Jet.OLEDB.4.0; Data Source=%s'  % self.baza
#             self.polaczenie=adodbapi.connect(parametr)
#            
#             
#         except Exception as e:
#             raise e
#             #komunikaty.blad_systemowy(e)
        
        
    def polaczOdbc(self):
        """"Połaczenie z bazą danych przy pomocy pyodbc"""
        try:
            drivers=[x for x in pyodbc.drivers() if x.startswith('Microsoft Access Driver')]#[x for x in pyodbc.drivers () if x.startswith('Microsoft Access Driver (*.mdb, *.accdb)')]
            self.polaczenie=pyodbc.connect(r"Driver={%s};DBQ=%s" % (drivers[0],self.baza))
            #self.polaczenie=pypyodbc.win_connect_mdb(self.baza)
 
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
    
    def zamknijPolaczenie(self):
        """Zamyka połączenie z bazą"""
        try:
            self.polaczenie.close()
        except Exception as e:
            ##Nie znalazem metody pokazujacej status polaczenia
            pass
            #komunikaty.blad_systemowy(e)
    
    def wykonajZapytanie(self,zapytanie):
        """Wykonuje zapytanie na bazie danych i zwraca dane (tuple)
        :param zapytanie; zapytanie sql
        :return dane
        """
        try:
            kursor=self.polaczenie.cursor()
            kursor.execute(zapytanie)
            dane=kursor.fetchall()
            kursor.close()
            del kursor
            return dane
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
    
#     def wykonajZapytanieTabela(self,zapytanie):
#         """Wykonuje zapytanie na bazie danych i zwraca dane w postaci 
    
    def zwrocKursor(self):
        """ Zwraca kursor z otwartego juz polaczenia. 
        :return kursor
        """
        try:
            if self.polaczenie:                
                return self.polaczenie.cursor()
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)    
            
            
    def wykonajWieleZapytan(self,zapytanie="",parametry=[()]):
        """ Wykonuje zapytanie typu insert,update bez zwracania wynikow dla wielu parametrow. 
        :param zapytanie:zapytanie sql
        :param parametry:parametry zapytania
        """
        try:
            if zapytanie and parametry:
                kursor=self.polaczenie.cursor()    
                kursor.executemany(zapytanie,parametry)
                kursor.commit()
                kursor.close()
                del kursor
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
            
    def wykonajZapytanieModyfikacja(self,zapytanie):
        """ Wykonuje zapytanie typu UPDATE bez zwracania wynikow. 
        :param zapytanie: zapytanie sql
        """
        try:
            kursor = self.polaczenie.cursor()
            kursor.execute(zapytanie)
            kursor.commit()
            kursor.close()
            del kursor
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)        
    
    def czyIstniejeTabela(self,nazwa):
        """Sprawdza istnienie tabeli w bazie danych
        :param nazwa; nazwa tabeli
        :return True/False
        """
        try:
            kursor=self.polaczenie.cursor()
            for tabela in kursor.tables():
                if tabela[2]==nazwa:
                    kursor.close()
                    del kursor
                    return True
            kursor.close()
            del kursor
            return False
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
            
    def liczbaWierszy(self,nazwa_tabeli):
        """Podaje liczbe wierszy w tabeli jezeli isteniaja przy otwartym juz polaczeniu
        :param nazwa_tabeli: nazwa tabeli
        :return liczba wierszy
        """
        try:
            if self.polaczenie:
                kursor=self.polaczenie.cursor()
                wynik = kursor.execute("SELECT Count(*) FROM "+nazwa_tabeli).fetchall()[0][0]
                kursor.close()
                del kursor
                return wynik
            else:
                return None 
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
            
    def czyIstniejePole(self,tabela,*kolumny):
        """Sprawdza istnienie pola w tabeli
        :param tabela:nazwa tabeli
        :param kolumny: nazwy kolumn
        :return wynik kontroli
        """
        try:
            kursor=self.polaczenie.cursor()
            lista=[nazwa[3] for nazwa in kursor.columns(table=tabela)]
            for k in kolumny:
                if (k in lista)==False:
                    return False
            return True
                        
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
        finally:
            kursor.close()
            del kursor


        
    